wxWidgets: wxGLContextAttrs Class Reference

| Version: 3.1.5

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxGLContextAttrs Class Reference
Class List by Category » OpenGL

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.1/wxWidgets3.1-3.1.5-4.x86_64/src/wxWidgets-3.1.5/interface/wx/glcanvas.h>`

Inheritance diagram for wxGLContextAttrs:
[legend]

## Detailed Description

This class is used for setting context attributes.

Since OpenGL version 3.0 the ARB adds attributes time to time to the rendering context functionality. wxWidgets implements attributes up to OGL 4.5, but you can set new attributes by using AddAttribute() and AddAttribBits() functions inherited from the base wxGLAttribsBase class.

Attributes can be chained. For example:

wxGLContextAttrs cxtAttrs;
cxtAttrs.CoreProfile().OGLVersion(4, 5).Robust().ResetIsolation().EndList();
wxGLContextAttrs
This class is used for setting context attributes.
Definition glcanvas.h:301
wxGLContextAttrs::Robust
wxGLContextAttrs & Robust()
Request robustness, or how OpenGL handles out-of-bounds buffer object accesses and graphics reset not...
wxGLContextAttrs::ResetIsolation
wxGLContextAttrs & ResetIsolation()
Request OpenGL to protect other applications or shared contexts from reset side-effects.
wxGLContextAttrs::CoreProfile
wxGLContextAttrs & CoreProfile()
Request an OpenGL core profile for the context.
wxGLContextAttrs::OGLVersion
wxGLContextAttrs & OGLVersion(int vmayor, int vminor)
An easy way of requesting an OpenGL version.
wxGLContextAttrs::EndList
void EndList()
The set of attributes must end with this one; otherwise, the GPU may display nothing at all.

Notice that EndList() must be used as the last attribute. Not adding it will likely result in nothing displayed at all.

Since
  3.1.0

##

Library: wxGL

<>< =''>:</>&;&;< =''>\ </></>

See also
  wxGLCanvas, wxGLContext, wxGLAttribsBase, wxGLAttributes

## Public Member Functions
wxGLContextAttrs & | CoreProfile ()
| Request an OpenGL core profile for the context.
wxGLContextAttrs & | MajorVersion (int val)
| Request specific OpenGL core major version number (>= 3).
wxGLContextAttrs & | MinorVersion (int val)
| Request specific OpenGL core minor version number.
wxGLContextAttrs & | OGLVersion (int vmayor, int vminor)
| An easy way of requesting an OpenGL version.
wxGLContextAttrs & | CompatibilityProfile ()
| Request a type of context with all OpenGL features from version 1.0 to the newest available by the GPU driver.
wxGLContextAttrs & | ForwardCompatible ()
| Request a forward-compatible context.
wxGLContextAttrs & | ES2 ()
| Request an ES or ES2 ("Embedded Subsystem") context.
wxGLContextAttrs & | DebugCtx ()
| Request debugging functionality.
wxGLContextAttrs & | Robust ()
| Request robustness, or how OpenGL handles out-of-bounds buffer object accesses and graphics reset notification behaviours.
wxGLContextAttrs & | NoResetNotify ()
| With robustness enabled, never deliver notification of reset events.
wxGLContextAttrs & | LoseOnReset ()
| With robustness enabled, if graphics reset happens, all context state is lost.
wxGLContextAttrs & | ResetIsolation ()
| Request OpenGL to protect other applications or shared contexts from reset side-effects.
wxGLContextAttrs & | ReleaseFlush (int val=1)
| Request OpenGL to avoid or not flushing pending commands when the context is made no longer current (released).
wxGLContextAttrs & | PlatformDefaults ()
| Set platform specific defaults.
void | EndList ()
| The set of attributes must end with this one; otherwise, the GPU may display nothing at all.
Public Member Functions inherited from wxGLAttribsBase
| wxGLAttribsBase ()
| Constructor.
void | AddAttribute (int attribute)
| Adds an integer value to the list of attributes.
void | AddAttribBits (int searchVal, int combineVal)
| Combine (bitwise OR) a given value with the existing one, if any.
void | SetNeedsARB (bool needsARB=true)
| Sets the necessity of using special ARB-functions (e.g.
void | Reset ()
| Delete contents and sets ARB-flag to false.
const int * | GetGLAttrs () const
| Returns a pointer to the internal list of attributes.
int | GetSize ()
| Returns the size of the internal list of attributes.
bool | NeedsARB () const
| Returns the current value of the ARB-flag.

## Member Function Documentation

## ◆ CompatibilityProfile()

wxGLContextAttrs & wxGLContextAttrs::CompatibilityProfile | ( |  | ) |

Request a type of context with all OpenGL features from version 1.0 to the newest available by the GPU driver.

In this mode the GPU may be some slower than it would be without this compatibility attribute.

## ◆ CoreProfile()

wxGLContextAttrs & wxGLContextAttrs::CoreProfile | ( |  | ) |

Request an OpenGL core profile for the context.

If the requested OpenGL version is less than 3.2, this attribute is ignored and the functionality of the context is determined solely by the requested version.

## ◆ DebugCtx()

wxGLContextAttrs & wxGLContextAttrs::DebugCtx | ( |  | ) |

Request debugging functionality.

This tells OpenGL to prepare a set where some logs are enabled and also allows OGL to send debug messages through a callback function.

It has no effect under macOS.

## ◆ EndList()

void wxGLContextAttrs::EndList | ( |  | ) |

The set of attributes must end with this one; otherwise, the GPU may display nothing at all.

## ◆ ES2()

wxGLContextAttrs & wxGLContextAttrs::ES2 | ( |  | ) |

Request an ES or ES2 ("Embedded Subsystem") context.

These are special subsets of OpenGL, lacking some features of the full specification. Used mainly in embedded devices such as mobile phones.

It has no effect under macOS.

## ◆ ForwardCompatible()

wxGLContextAttrs & wxGLContextAttrs::ForwardCompatible | ( |  | ) |

Request a forward-compatible context.

Forward-compatible contexts are defined only for OpenGL versions 3.0 and later. They must not support functionality marked as deprecated or removed by the requested version of the OpenGL API.

It has no effect under macOS.

## ◆ LoseOnReset()

wxGLContextAttrs & wxGLContextAttrs::LoseOnReset | ( |  | ) |

With robustness enabled, if graphics reset happens, all context state is lost.

It has no effect under macOS.

## ◆ MajorVersion()

wxGLContextAttrs & wxGLContextAttrs::MajorVersion | ( | int | val | ) |

Request specific OpenGL core major version number (>= 3).

Parameters

  val | The major version number requested.

It has no effect under macOS where specifying CoreProfile() will result in using OpenGL version at least 3.2.

## ◆ MinorVersion()

wxGLContextAttrs & wxGLContextAttrs::MinorVersion | ( | int | val | ) |

Request specific OpenGL core minor version number.

Parameters

  val | The minor version number requested, e.g. 2 if OpenGL 3.2 is requested.

It has no effect under macOS where specifying CoreProfile() will result in using OpenGL version at least 3.2.

## ◆ NoResetNotify()

wxGLContextAttrs & wxGLContextAttrs::NoResetNotify | ( |  | ) |

With robustness enabled, never deliver notification of reset events.

It has no effect under macOS.

## ◆ OGLVersion()

wxGLContextAttrs & wxGLContextAttrs::OGLVersion | ( | int | vmayor,
|  | int | vminor )

An easy way of requesting an OpenGL version.

Parameters

  vmayor | The major version number requested, e.g. 4 if OpenGL 4.5 is requested.
  vminor | The minor version number requested, e.g. 5 if OpenGL 4.5 is requested.

It has no effect under macOS where specifying CoreProfile() will result in using OpenGL version at least 3.2.

## ◆ PlatformDefaults()

wxGLContextAttrs & wxGLContextAttrs::PlatformDefaults | ( |  | ) |

Set platform specific defaults.

Currently only Unix defaults are implemented: use X11 direct rendering and use X11 RGBA type.

## ◆ ReleaseFlush()

wxGLContextAttrs & wxGLContextAttrs::ReleaseFlush | ( | int | val = 1 | ) |

Request OpenGL to avoid or not flushing pending commands when the context is made no longer current (released).

If you don't specify this attribute, the GPU driver default is 'flushing'.

Parameters

  val | 0 for not flushing, 1 (wxWidgets default) for flushing pending commands.

It has no effect under macOS.

## ◆ ResetIsolation()

wxGLContextAttrs & wxGLContextAttrs::ResetIsolation | ( |  | ) |

Request OpenGL to protect other applications or shared contexts from reset side-effects.

It has no effect under macOS.

## ◆ Robust()

wxGLContextAttrs & wxGLContextAttrs::Robust | ( |  | ) |

Request robustness, or how OpenGL handles out-of-bounds buffer object accesses and graphics reset notification behaviours.

It has no effect under macOS.